/* fipstest: generate test messages from FIPS and SHAVS documents */

/* $Id: fipstest.c 24 2006-04-15 16:14:32Z selinger $ */

#include <stdio.h>

static char *str1 = "abc";
static char *str2 = "abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq";
static char vec4[] = { 0x19 };
static char vec5[] = {
  0xe3, 0xd7, 0x25, 0x70, 0xdc, 0xdd, 0x78, 0x7c, 
  0xe3, 0x88, 0x7a, 0xb2, 0xcd, 0x68, 0x46, 0x52,
};
static char vec6[] = {
  0x83, 0x26, 0x75, 0x4e, 0x22, 0x77, 0x37, 0x2f,
  0x4f, 0xc1, 0x2b, 0x20, 0x52, 0x7a, 0xfe, 0xf0,
  0x4d, 0x8a, 0x05, 0x69, 0x71, 0xb1, 0x1a, 0xd5,
  0x71, 0x23, 0xa7, 0xc1, 0x37, 0x76, 0x00, 0x00,
  0xd7, 0xbe, 0xf6, 0xf3, 0xc1, 0xf7, 0xa9, 0x08,
  0x3a, 0xa3, 0x9d, 0x81, 0x0d, 0xb3, 0x10, 0x77,
  0x7d, 0xab, 0x8b, 0x1e, 0x7f, 0x02, 0xb8, 0x4a,
  0x26, 0xc7, 0x73, 0x32, 0x5f, 0x8b, 0x23, 0x74,
  0xde, 0x7a, 0x4b, 0x5a, 0x58, 0xcb, 0x5c, 0x5c,
  0xf3, 0x5b, 0xce, 0xe6, 0xfb, 0x94, 0x6e, 0x5b,
  0xd6, 0x94, 0xfa, 0x59, 0x3a, 0x8b, 0xeb, 0x3f,
  0x9d, 0x65, 0x92, 0xec, 0xed, 0xaa, 0x66, 0xca,
  0x82, 0xa2, 0x9d, 0x0c, 0x51, 0xbc, 0xf9, 0x33,
  0x62, 0x30, 0xe5, 0xd7, 0x84, 0xe4, 0xc0, 0xa4,
  0x3f, 0x8d, 0x79, 0xa3, 0x0a, 0x16, 0x5c, 0xba,
  0xbe, 0x45, 0x2b, 0x77, 0x4b, 0x9c, 0x71, 0x09,
  0xa9, 0x7d, 0x13, 0x8f, 0x12, 0x92, 0x28, 0x96,
  0x6f, 0x6c, 0x0a, 0xdc, 0x10, 0x6a, 0xad, 0x5a,
  0x9f, 0xdd, 0x30, 0x82, 0x57, 0x69, 0xb2, 0xc6,
  0x71, 0xaf, 0x67, 0x59, 0xdf, 0x28, 0xeb, 0x39,
  0x3d, 0x54, 0xd6,
};
static char vec7[] = { 0x5e };
static char vec8[] = {
  0x9a, 0x7d, 0xfd, 0xf1, 0xec, 0xea, 0xd0, 0x6e, 
  0xd6, 0x46, 0xaa, 0x55, 0xfe, 0x75, 0x71, 0x46,
};
static char vec9[] = {
  0xf7, 0x8f, 0x92, 0x14, 0x1b, 0xcd, 0x17, 0x0a,
  0xe8, 0x9b, 0x4f, 0xba, 0x15, 0xa1, 0xd5, 0x9f,
  0x3f, 0xd8, 0x4d, 0x22, 0x3c, 0x92, 0x51, 0xbd,
  0xac, 0xbb, 0xae, 0x61, 0xd0, 0x5e, 0xd1, 0x15,
  0xa0, 0x6a, 0x7c, 0xe1, 0x17, 0xb7, 0xbe, 0xea,
  0xd2, 0x44, 0x21, 0xde, 0xd9, 0xc3, 0x25, 0x92,
  0xbd, 0x57, 0xed, 0xea, 0xe3, 0x9c, 0x39, 0xfa,
  0x1f, 0xe8, 0x94, 0x6a, 0x84, 0xd0, 0xcf, 0x1f,
  0x7b, 0xee, 0xad, 0x17, 0x13, 0xe2, 0xe0, 0x95,
  0x98, 0x97, 0x34, 0x7f, 0x67, 0xc8, 0x0b, 0x04,
  0x00, 0xc2, 0x09, 0x81, 0x5d, 0x6b, 0x10, 0xa6,
  0x83, 0x83, 0x6f, 0xd5, 0x56, 0x2a, 0x56, 0xca,
  0xb1, 0xa2, 0x8e, 0x81, 0xb6, 0x57, 0x66, 0x54,
  0x63, 0x1c, 0xf1, 0x65, 0x66, 0xb8, 0x6e, 0x3b,
  0x33, 0xa1, 0x08, 0xb0, 0x53, 0x07, 0xc0, 0x0a,
  0xff, 0x14, 0xa7, 0x68, 0xed, 0x73, 0x50, 0x60,
  0x6a, 0x0f, 0x85, 0xe6, 0xa9, 0x1d, 0x39, 0x6f,
  0x5b, 0x5c, 0xbe, 0x57, 0x7f, 0x9b, 0x38, 0x80,
  0x7c, 0x7d, 0x52, 0x3d, 0x6d, 0x79, 0x2f, 0x6e,
  0xbc, 0x24, 0xa4, 0xec, 0xf2, 0xb3, 0xa4, 0x27,
  0xcd, 0xbb, 0xfb,
};

void test3() {
  int i;
  for (i=0; i<1000000; i++) {
    fputc('a', stdout);
  }
}

void print_string(char *str) {
  fputs(str, stdout);
}

void print_bytes(char *p, int n) {
  fwrite(p, 1, n, stdout);
}

int main(int ac, char *av[]) {
  if (ac != 2) {
    fprintf(stderr, "Usage: %s <n> - generate nth test stream\n", av[0]);
    return 1;
  }

  switch (av[1][0]) {
  case '1': 
    print_string(str1);
    break;
  case '2':
    print_string(str2);
    break;
  case '3':
    test3();
    break;
  case '4':
    print_bytes(vec4, sizeof(vec4));
    break;
  case '5':
    print_bytes(vec5, sizeof(vec5));
    break;
  case '6':
    print_bytes(vec6, sizeof(vec6));
    break;
  case '7':
    print_bytes(vec7, sizeof(vec7));
    break;
  case '8':
    print_bytes(vec8, sizeof(vec8));
    break;
  case '9':
    print_bytes(vec9, sizeof(vec9));
    break;
  default:
    fprintf(stderr, "Usage: %s <n> - generate nth test stream\n", av[0]);
    return 1;
  }
  return 0;
}
