/* $Id: sha1.h 36 2006-07-21 09:11:02Z selinger $ */

#ifndef SHA1_H
#define SHA1_H

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#ifdef HAVE_STDINT_H
# include <stdint.h>
#endif

#include "hash.h"

struct sha1_state_s {
  uint32_t count_hi, count_lo;  /* how many bits processed total */
  uint32_t j;                   /* how many bytes processed in current block */
  uint32_t W[16];               /* 16 words message schedule */
  uint32_t H[5];                /* hash value */
};
typedef struct sha1_state_s sha1_state_t;

void sha1_init(sha1_state_t *s);
void sha1_byte(sha1_state_t *s, int x);
void sha1_bytes(sha1_state_t *s, unsigned char *p, int n);
void sha1_finish(sha1_state_t *s);
void sha1_finish_with_bits(sha1_state_t *s, int n, unsigned char buf);
void sha1_gethash(sha1_state_t *s, unsigned char *p);

hash_object_t *sha1_new(void);

#endif /* SHA1_H */

